/*
Printblobs - typography display hack
Copyright (C) 2013  John Tsiombikas <nuclear@member.fsf.org>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
varying vec3 normal, vpos;

void main()
{
	vec3 n = normalize(normal);
	vec3 v = -normalize(vpos);

	vec3 color = vec3(0.0, 0.0, 0.0);

	for(int i=0; i<2; i++) {
		vec3 l = normalize(gl_LightSource[i].position.xyz);
		vec3 h = normalize(v + l);

		float ndotl = max(dot(n, l), 0.0);
		float ndoth = max(dot(n, h), 0.0);
		float spec = pow(ndoth, gl_FrontMaterial.shininess);

		vec3 dcol = gl_FrontMaterial.diffuse.xyz * gl_LightSource[i].diffuse.xyz;
		vec3 scol = gl_FrontMaterial.specular.xyz * gl_LightSource[i].diffuse.xyz;

		color += dcol * ndotl + scol * spec;
	}

	vec3 acol = gl_FrontMaterial.ambient.xyz * gl_LightModel.ambient.xyz;

	gl_FragColor.xyz = acol + color;
	gl_FragColor.w = 1.0;
}
